// $Id$
//
// Copyright (C) 2006 

// TODO: error logging

// Definition of non-inline non-template functions

#include "HTTPLogger.hh"
//#include "HTTPLogger.ih"

// Custom includes
#include "Socket/Protocols/INet/INetAddressing.hh"
#include "Socket/CommunicationPolicy.hh"

//#include "HTTPLogger.mpp"
#define prefix_
///////////////////////////////cc.p////////////////////////////////////////

namespace {

    std::string currentDateTimeString()
    {
	time_t t;
	time(&t);
	char buffer[32];
	strftime(buffer,32,"%d/%b/%Y:%H:%M:%S %z",localtime(&t));
	buffer[31] = 0;
	return std::string(buffer);
    }

}

prefix_ g0dil::mediaserv::HTTPLogger::HTTPLogger(std::string logfile)
    : logFile_(logfile.c_str(),std::ofstream::app)
{
    if (!logFile_)
	throw InvalidLogFileException();
    logFile_ << "(start)" << " - - [" << currentDateTimeString() << "] mediaserv started" 
	     << std::endl;
}

prefix_ g0dil::mediaserv::HTTPLogger::~HTTPLogger()
{
    logFile_ << "(shutdown)" << " - - [" << currentDateTimeString() << "] mediaserv terminated" 
	     << std::endl;
}

prefix_ void g0dil::mediaserv::HTTPLogger::invalidRequest(std::string message)
{
    logFile_ << "(unknown client)" << " - - [" << currentDateTimeString() << "] " 
	     << "invalid request: " << message << std::endl;
}

prefix_ void g0dil::mediaserv::HTTPLogger::invalidRequest(HTTPRequest const & request,
                                                          std::string message)
{
    logFile_ << request.host() << " - - [" << currentDateTimeString() << "] ";
    if (!request.method().empty())
	logFile_ << "\"" << request.method() << " " << request.url() << " " << request.version() << "\" ";
    logFile_ << "invalid request: " << message << std::endl;
}

prefix_ void g0dil::mediaserv::HTTPLogger::failedRequest(std::string message)
{
    logFile_ << "(unknown client)" << " - - [" << currentDateTimeString() << "] " 
	     << "failed request: " << message << std::endl;
}

prefix_ void g0dil::mediaserv::HTTPLogger::failedRequest(HTTPRequest const & request,
                                                         std::string message)
{
    logFile_ << request.host() << " - - [" << currentDateTimeString() << "] ";
    if (!request.method().empty())
	logFile_ << "\"" << request.method() << " " << request.url() << " " << request.version() << "\" ";
    logFile_ << "invalid request: " << message << std::endl;
}

prefix_ void g0dil::mediaserv::HTTPLogger::request(HTTPRequest const & request, 
                                                   unsigned bytes)
{
    logFile_ << request.host() << " - - [" << currentDateTimeString() << "] "
	     << "\"" << request.method() << " " << request.url() << " " << request.version()
	     << "\" 200 " << bytes << " \"\" \"\"" << std::endl;
}

///////////////////////////////cc.e////////////////////////////////////////
#undef prefix_
//#include "HTTPLogger.mpp"


// Local Variables:
// mode: c++
// End:
