// $Id$
//
// Copyright (C) 2006 

#ifndef HH_SimpleHTTPServer_
#define HH_SimpleHTTPServer_ 1

// Custom includes
#include <set>
#include <boost/utility.hpp>
#include "Socket/ServerSocketHandle.hh"
#include "Socket/CommunicationPolicy.hh"
#include "Socket/FramingPolicy.hh"
#include "Socket/ReadWritePolicy.hh"
#include "Scheduler/Scheduler.hh"

#include "HTTPLogger.hh"
#include "HTTPConnection.hh"

//#include "SimpleHTTPServer.mpp"
///////////////////////////////hh.p////////////////////////////////////////

namespace g0dil {
namespace mediaserv {

    class SimpleHTTPServer
	: boost::noncopyable
    {
    public:
        ///////////////////////////////////////////////////////////////////////////
        // Types

	typedef HTTPConnection::ClientHandle::ServerSocketHandle ServerHandle;

        ///////////////////////////////////////////////////////////////////////////
        ///\name Structors and default members
        ///@{

        SimpleHTTPServer(ServerHandle socket, HTTPLogger & logger);
        ~SimpleHTTPServer();

	static SimpleHTTPServer & instance();

        ///@}
        ///////////////////////////////////////////////////////////////////////////

	void done(HTTPConnection::ptr connection);

    protected:

    private:
	void newConnection(ServerHandle handle, senf::Scheduler::EventId event);

	typedef std::set<HTTPConnection::ptr> Connections;

	ServerHandle socket_;
	HTTPLogger & logger_;
	Connections connections_;

	static SimpleHTTPServer * instance_;
    };

}}

///////////////////////////////hh.e////////////////////////////////////////
#include "SimpleHTTPServer.cci"
//#include "SimpleHTTPServer.ct"
//#include "SimpleHTTPServer.cti"
//#include "SimpleHTTPServer.mpp"
#endif


// Local Variables:
// mode: c++
// End:
